<template>
  <article class="view view--messaging-messages-conversation">
    <MessagingMessageList :username="username" :offset="offset" :limit="limit" />
  </article>
</template>

<script>
import { computed } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { Constants, ValidationHelper } from '../../../core'
import MessagingMessageList from '../../components/message-list.vue'

export default {
  name: 'MessagingMessagesConversationView',
  components: {
    MessagingMessageList,
  },
  setup() {
    const route = useRoute()
    const store = useStore()

    const username = computed(() => {
      return ValidationHelper.getString(route.params.username, '')
    })

    const offset = computed(() => {
      return ValidationHelper.getInteger(route.query.offset, -1)
    })

    const limit = computed(() => {
      return ValidationHelper.getInteger(route.query.limit, Constants.pagination.defaultPageLimit)
    })

    const title = computed(() => {
      return store.state.identity.session.username
    })

    const iconClass = computed(() => {
      return route.meta.iconClass
    })

    const breadcrumbs = computed(() => {
      return [
        {
          text: 'Account',
          route: { name: 'identity-account' },
        },
        {
          text: 'Messages',
          route: { name: 'messaging-messages-overview' },
        },
        {
          text: title.value,
          route: null, // No link to self
        },
      ]
    })

    store.dispatch('core/setTitle', title.value)
    store.dispatch('core/setIconClass', iconClass.value)
    store.dispatch('core/setBreadcrumbs', breadcrumbs.value)

    return {
      username,
      offset,
      limit,
      title,
      iconClass,
      breadcrumbs,
    }
  },
}
</script>
